seo:
  title: "10\_bonnes pratiques pour tirer parti de GitLab\_Duo\_Chat alimenté par l'IA"
  description: "Découvrez nos conseils et astuces pour intégrer GitLab\_Duo\_Chat à vos workflows DevSecOps alimentés par l'IA. Profitez également de conseils d'experts pour personnaliser vos prompts afin d'obtenir des résultats optimaux."
  ogTitle: "10\_bonnes pratiques pour tirer parti de GitLab\_Duo\_Chat alimenté par l'IA"
  ogDescription: "Découvrez nos conseils et astuces pour intégrer GitLab\_Duo\_Chat à vos workflows DevSecOps alimentés par l'IA. Profitez également de conseils d'experts pour personnaliser vos prompts afin d'obtenir des résultats optimaux."
  noIndex: false
  ogImage: images/blog/hero-images/blog-image-template-1800x945-(1).png
  ogUrl: >-
    https://about.gitlab.com/blog/10-best-practices-for-using-ai-powered-gitlab-duo-chat
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: >-
    https://about.gitlab.com/blog/10-best-practices-for-using-ai-powered-gitlab-duo-chat
  schema: "\n                        {\n        \"@context\": \"https://schema.org\",\n        \"@type\": \"Article\",\n        \"headline\": \"10\_bonnes pratiques pour tirer parti de GitLab\_Duo\_Chat alimenté par l'IA\",\n        \"author\": [{\"@type\":\"Person\",\"name\":\"Michael Friedrich\"}],\n        \"datePublished\": \"2024-04-02\",\n      }\n                  "
content:
  title: "10\_bonnes pratiques pour tirer parti de GitLab\_Duo\_Chat alimenté par l'IA"
  description: "Découvrez nos conseils et astuces pour intégrer GitLab\_Duo\_Chat à vos workflows DevSecOps alimentés par l'IA. Profitez également de conseils d'experts pour personnaliser vos prompts afin d'obtenir des résultats optimaux."
  authors:
    - Michael Friedrich
  heroImage: images/blog/hero-images/blog-image-template-1800x945-(1).png
  date: '2024-04-02'
  body: "Entamer une conversation avec l'IA peut s'avérer difficile. Par quelle question commencer\_? Comment la formuler\_? Quel degré de contexte est nécessaire\_? La conversation fournira-t-elle des résultats optimaux et efficaces\_?\n\nDans ce tutoriel, découvrez 10\_conseils et bonnes pratiques pour intégrer GitLab\_Duo\_Chat dans vos workflows DevSecOps alimentés par l'IA et personnaliser vos prompts afin d'obtenir des résultats optimaux.\n\n[Première étape\_: activer GitLab\_Duo\_Chat au premier plan](#get-started-keep-gitlab-duo-chat-open-and-in-sight)\n\n[10\_bonnes pratiques à suivre pour une utilisation efficace de GitLab\_Duo\_Chat](#10-best-practices-for-using-gitlab-duo-chat)\n\n1. [Discutez](#1.-have-a-conversation)\n2. [Affinez le prompt pour gagner en efficacité](#2.-refine-the-prompt-for-more-efficiency)\n3. [Suivez des patterns de prompt](#3.-follow-prompt-patterns)\n4. [Utilisez une communication à contexte faible](#4.-use-low-context-communication)\n5. [Répétez la question](#5.-repeat-yourself)\n6. [Faites preuve de patience](#6.-be-patient)\n7. [Réinitialisez la conversation et lancez-en une nouvelle](#7.-reset-and-start-anew)\n8. [Gagnez en productivité en utilisant les commandes slash dans l'IDE](#8.-gain-efficiency-with-slash-commands-in-the-ide)\n9. [Affinez le prompt pour les commandes slash](#9.-refine-the-prompt-for-slash-commands)\n10. [Utilisez les commandes slash de manière créative](#10.-get-creative-with-slash-commands)\n\nContenus supplémentaires\_:\n- [Raccourcis](#shortcuts)\n- [Exercices amusants](#fun-exercices)\n- [En savoir plus](#learn-more)\n\n> Démo en direct\_! Découvrez tout ce que vous devez savoir sur l'avenir du développement logiciel piloté par l'IA lors de notre événement virtuel à l'occasion du lancement de GitLab\_17. [Inscrivez-vous dès aujourd'hui\_!](https://about.gitlab.com/fr-fr/seventeen/)\n\n## Première étape\_: ouvrir GitLab\_Duo\_Chat au premier plan\n\n[GitLab\_Duo\_Chat](https://docs.gitlab.com/ee/user/gitlab_duo_chat.html) est disponible dans l'interface utilisateur (UI) GitLab, dans le Web\_IDE et dans les IDE de programmation pris en charge, comme VS\_Code. \n\nDans VS\_Code, vous pouvez ouvrir GitLab\_Duo\_Chat dans le volet de gauche par défaut. Vous pouvez également glisser-déposer l'icône dans le volet de droite. Ainsi, GitLab\_Duo\_Chat reste ouvert pendant que vous écrivez du code et que vous naviguez dans l'arborescence des fichiers, que vous effectuez des actions Git et ainsi de suite. Pour réinitialiser l'emplacement de Chat, ouvrez la palette de commandes (en appuyant sur le raccourci clavier `Command+Maj+P` (sous macOS) ou `Ctrl+Maj+P` (sous Windows/Linux), puis saisissez `View: Reset View Locations`. La procédure à suivre est illustrée dans cette courte vidéo.\n\n<!-- blank line -->\n<figure class=\"video_container\">\n  <iframe src=\"https://www.youtube.com/embed/foZpUvWPRJQ\" frameborder=\"0\" allowfullscreen=\"true\"> </iframe>\n</figure>\n<!-- blank line -->\n\nLe Web\_IDE et VS\_Code partagent le même framework\_: la même méthode fonctionne dans le Web\_IDE pour proposer des workflows plus efficaces.\n\n![Chat dans le Web\_IDE](//images.ctfassets.net/r9o86ar0p03f/3g2laogkDFcgDFdvznBKSK/457b2579f799c9610750a5561ccd35d6/image1.png)\n\n## 10\_bonnes pratiques à suivre pour une utilisation efficace de GitLab\_Duo\_Chat\n\n### 1. Discutez\n\nLes chats sont des conversations, pas des formulaires de recherche.\n\nPour lancer la conversation, vous pouvez commencer avec les termes de recherche que vous utiliseriez lors d'une recherche par navigateur et expérimenter en fonction de la réponse et des données de sortie. Dans cet exemple, commençons par un projet\_C# et les bonnes pratiques associées. \n\n> c# start project best practices (bonnes pratiques de démarrage d'un projet C#)\n\n![Prompt demandant les bonnes pratiques de démarrage d'un projet C# et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/i490Yk1uv5ykAcZd31u1z/9a490630eef22e8c76b9dd4e8c4f7686/image11.png)\n\nLa réponse est utile pour comprendre un large champ d'application du langage C#, mais ne propose pas immédiatement de bonnes pratiques. Poursuivons avec une question plus ciblée dans le même contexte. \n\n> Please show the project structure for the C# project. (Montrez-moi la structure du projet\_C#.)\n\n![Prompt demandant la structure du projet\_C# et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/2YkqiNsRk4ZlXzQ7HFMZQk/e086dfe5c35c0de9ebb0c8f880da1e01/image9.png)\n\nCette réponse est utile. Poursuivons avec une question relative à Git et utilisons la même structure\_: demandons directement à l'IA de nous montrer un exemple.\n\n> Show an example for a .gitignore for C# (Montrez-moi un exemple de fichier .gitignore en langage\_C#)\n\n![Prompt demandant un exemple de fichier .gitignore en langage\_C# et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/1PuAowm5O4PTUe98UA43vY/e0b063001ffad64d192110144f250d97/image25.png)\n\nPoursuivez avec les pratiques\_CI/CD et demandez à l'IA comment créer le projet\_C#.\n\n> Show a GitLab CI/CD configuration for building the C# project (Montrez-moi une configuration GitLab\_CI/CD adaptée à la création du projet\_C#)\n\n![Prompt demandant un exemple de configuration de GitLab\_CI/CD pour la création du projet C# et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/7ghHitWNJ8FHmGI53FvAa8/c76156f14ab8d57fa629fecada878026/image16.png)\n\nDans cet exemple, GitLab\_Duo\_Chat nous a encouragés à demander des modifications spécifiques. Demandons-lui d'utiliserle SDK .NET\_8.0 au lieu du SDK .NET\_6.0. \n\n> In the above example, please use the .NET SDK 8.0 image (Dans l'exemple ci-dessus, utilisezl'image du SDK .NET\_8.0)\n\n![Prompt demandant à GitLab\_Duo\_Chat d'utiliserl'image du SDK .NET\_8.0 et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/1SpfMN3PslKMCIVyEc0SJh/324b426aaea4a5ee6a11f462979ddec3/image32.png)\n\nLa configuration CI/CD utilisel'interface de ligne de commande (CLI) .NET. Essayons de suivre cette bonne pratique pour générer des commandes plus efficaces afin de créer la structure des projets et des tests. \n\n> Explain how to create projects and test structure on the CLI (Expliquez-moi comment créer des projets et tester la structure sur l'interface CLI) \n\n![Prompt demandant d'expliquer comment créer des projets et tester la structure sur l'interface CLI et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/343UrD8PCho5AFRYDR5UVH/eb8f8279cb27830d48941b3e7ecdac48/image14.png)\n\nNous pourrions exécuter ces commandes dans le terminal, mais, pour cet exemple, imaginons que nous souhaitions rester dans VS\_Code. Posons la question à Chat.\n\n> Explain how to open a new terminal in VS Code (Expliquez-moi comment ouvrir un nouveau terminal dans VS\_Code)\n\n![Prompt demandant d'expliquer comment ouvrir un nouveau terminal dans VS\_Code et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/67rZkRixE8BOdenC2jwDxF/aaf68e416a0721d416f1372d876e9943/image5.png)\n\n### 2. Affinez le prompt pour gagner en productivité\n\nConsidérez GitLab\_Duo\_Chat comme un être humain et utilisez des phrases complètes qui fournissent suffisamment de contexte à vos pensées et à vos questions. \n\nSi vous êtes un utilisateur expérimenté de la recherche par navigateur, vous connaissez peut-être l'approche qui consiste à concevoir la question, ajouter plus de termes pour affiner sa portée et redémarrer la recherche après avoir ouvert de nombreux onglets. \n\nDans le cas d'une recherche par navigateur, vous obtiendriez probablement quatre à cinq\_fenêtres de recherche différentes. \n\n```markdown\nc# start project best practices\nc# .gitignore\nc# gitlab cicd \nc# gitlab security scanning \nc# solutions and projects, application and tests\n``` \n\nVous pouvez également utiliser cette stratégie lors d'une conversation avec GitLab\_Duo\_Chat. Cela nécessite d'ajouter plus de contexte afin de la transformer en une approche conversationnelle. GitLab\_Duo\_Chat vous permet de poser plusieurs questions dans une même conversation. Exemple\_: vous devez commencer par un nouveau projet\_C#, appliquer les bonnes pratiques, ajouter un fichier `.gitignore` et configurer CI/CD ainsi qu'un scanning de sécurité, comme dans la recherche ci-dessus. Dans Chat, vous pouvez regrouper plusieurs questions dans une même demande.\n\n> How can I get started creating an empty C# console application in VS\_Code? Please show a .gitignore and .gitlab-ci.yml configuration with steps for C#, and add security scanning for GitLab. Explain how solutions and projects in C# work, and how to add a test project on the CLI. (Comment créer une application console C# vide dans VS\_Code\_? Montrez-moi un exemple de configuration .gitignore et .gitlab-ci.yml et les étapes associées en C# et ajoutez le scanning de sécurité pour GitLab. Expliquez-moi le fonctionnement des solutions et projets en C# et comment ajouter un projet test sur la CLI.)\n\n![Prompt demandant d'ajouter plus de contexte et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/2ndEBUzzu54As2iVP9gIez/6b9e681f1f05d8a5b1107acad3582332/image37.png)\n\nDans cette réponse, Chat suggère de demander des exemples de configuration spécifiques dans les questions de suivi de la conversation. Pratique asynchrone\_: créez des questions de suivi. Vous pouvez omettre `C# ` comme contexte dans la même session de chat.\n\n> Please show an example for a .gitignore. Please show a CI/CD configuration. Include the SAST template. (Montrez-moi un exemple de configuration .gitignore. Montrez-moi une configuration CI/CD. Incluez le modèle SAST.)\n\n### 3. Suivez des patterns de prompt \n\nSuivez le pattern\_: `Énoncer le problème, demander de l'aide, fournir des demandes supplémentaires`. Vous ne pouvez pas penser à tout lorsque vous posez la première question. Commencez par `énoncer le problème, demander de l'aide` lors de la première itération. \n\n> I need to fulfill compliance requirements. How can I get started with Codeowners and approval rules\_? (Je dois respecter les exigences de conformité. Comment utiliser les Codeowners et les règles d'approbation\_?) \n\n![Prompt demandant de l'aide au sujet des Codeowners et des règles d'approbation et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/6PvMtBxgHTg1mVvmoK2wzm/701d9809a51c9b261ead5adbe309d97a/image19.png)\n\nMême si la réponse est utile, elle reste générique. Vous pouvez maintenant obtenir une aide spécifique pour la configuration de votre équipe. \n\n> Please show an example for Codeowners with different teams\_: backend, frontend, release managers. (Montrez-moi un exemple de Codeowners pour différentes équipes\_: backend, frontend, release managers.)\n\n![Prompt demandant un exemple de fichier Codeowners pour différentes équipes (backend, frontend, managers de release) et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/6meZplniPOhV7bi7ZhEWLb/55ece7f9d9b64034132bfb57975d6078/image31.png)\n\nUne alternative consiste à décrire la situation dans laquelle vous vous trouvez et à demander de l'aide. Suivez le modèle STAR (Situation, Tâche, Action et Résultat) pour construire votre conversation. \n\n> I have a Kubernetes cluster integrated in GitLab. Please generate a Yaml configuration for a Kubernetes service deployment. Explain how GitOps works as a second step. How to verify the results? (Je dispose d'un cluster Kubernetes intégré dans GitLab. Générez une configuration Yaml correspondant à un déploiement de service Kubernetes. Expliquez-moi ensuite le fonctionnement de GitOps. Comment puis-je vérifier les résultats\_?)\n\n![Prompt incluant plusieurs questions et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/5WsLzp1xFbcExTGfqOLCRe/ec71bacc9b62f4041edcbb9bb08a6348/image27.png)\n\n### 4. Utilisez une communication à contexte faible \n\nFournissez autant de contexte que nécessaire pour obtenir une réponse. L'historique précédent ou le code source ouvert ne fournit parfois pas de contexte utile. Pour obtenir une réponse plus adaptée, appliquez un pattern de [communication à contexte faible](https://handbook.gitlab.com/handbook/company/culture/all-remote/effective-communication/#understanding-low-context-communication), qui est utilisé dans les communications 100\_% à distance chez GitLab.\n\nLa question suivante ne fournit pas suffisamment de contexte dans le cadre d'un projet C++.\n\n> Should I use virtual override instead of just override? (Dois-je utiliser un remplacement virtuel au lieu d'un simple remplacement\_?)\n\n![Prompt demandant si les utilisateurs doivent utiliser le remplacement virtuel au lieu d'un simple remplacement et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/1LYlvCeyAurCDj8jQsPbfb/3103c2c9243ddd40f13ab29f9738d918/image34.png)\n\nEssayez plutôt d'ajouter davantage de contexte\_:\n\n> When implementing a pure virtual function in an inherited class, should I use virtual function override, or just function override? Context is C++. (Lors de la mise en œuvre d'une fonction virtuelle pure dans une classe dérivée, dois-je utiliser le remplacement de fonction virtuelle ou simplement le remplacement de fonction dans le cadre d'un projet C++\_?)  \n\n![Prompt offrant plus de détails et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/5fR29wnHxnuftVGFpMCStQ/399fdc6015980ad002e2052ef7d8ec3c/image36.png)\n\nVous pouvez également consulter l'exemple dans la vidéo [GitLab\_Duo Coffee Chat\_: Refactor C++ functions into OOP classes for abstract database handling](https://youtu.be/Z9EJh0J9358?t=2190). \n\n### 5. Répétez la question\n\nL'IA n'est pas prévisible. Sa réponse peut parfois différer des résultats attendus, ou elle ne produit pas d'exemples de code source ni d'extraits de code de configuration en raison du manque de contexte. Il est recommandé de répéter la question et de préciser les conditions requises.\n\nDans l'exemple suivant, nous voulons créer une application C#. Lors de la première tentative, nous n'avons pas spécifié le type d'application alors que le langage C# peut servir à créer une console/un terminal ou des applications d'interface utilisateur. Le résultat ne fournit pas non plus d'exemple de code source vide. Le second prompt répété ajoute deux mots supplémentaires\_: `console` et `empty` (vide). \n\n> How can I get started creating an C# application in VS\_Code? (Comment créer une application C# dans VS\_Code\_?)\n> \n> How can I get started creating an empty C# console application in VS\_Code? (Comment créer une application console C# vide dans VS\_Code\_?)\n\nLes résultats du prompt diffèrent. La première réponse est utile pour commencer en suivant les instructions dans la fenêtre VS\_Code, mais elle ne nous indique pas où se trouve le code source et comment le modifier. La réponse obtenue suite à la répétition et à l'amélioration du prompt fournit des instructions sur la façon de remplacer le modèle par défaut par un code de type «\_hello world\_».\n\n![Répétition/modification du prompt et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/2N52TAtf5U28SUr3xCAc94/151036ed163b1d8a00ca5c6ae1dd96e9/image28.png)\n\nVous pouvez également combiner des répétitions et des personnalisations, et demander à Chat de montrer un exemple de code d'application et de tests.\n\n> How can I get started creating an empty C# console application in VSCode? Please show an example for application and tests. (Comment créer une application console C# vide dans VS\_Code\_? Montrez-moi un exemple d'application et de tests.)\n\n![Prompt demandant un exemple d'application et de tests et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/6DX8VwKV2mh6jmAOAwqMPy/5e54e2be575eec9244617023d63eca4a/image3.png)\n\n#### Répétez la question après avoir posé des questions génériques \n\nLorsque vous posez des questions génériques sur la technologie, GitLab\_Duo\_Chat peut ne pas être en mesure de vous aider. Dans le scénario suivant, nous n'avons pas pu obtenir de suggestion de framework et d'outils de compilation Java. Les possibilités de réponse sont trop nombreuses\_: elles peuvent concerner des outils de compilation tels que Maven et Gradle et [plus de 100\_frameworks Java](https://fr.wikipedia.org/wiki/Liste_de_frameworks_Java), selon la pile technologique et les conditions requises.\n\n![Prompt demandant un framework et des outils de compilation Java et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/1iJc7hO53FF85ODZ3PvTMP/917b11e1f999999c8965473a84836838/image2.png)\n\nNous souhaitons maintenant nous concentrer sur un environnement client avec [Java Spring Boot](https://spring.io/projects/spring-boot). \n\n> I want to create a Java Spring Boot application. Please explain the project structure and show a hello world example. (Je souhaite créer une application Java Spring Boot. Décrivez-moi la structure du projet et montrez-moi un exemple hello world.) \n\n![Prompt demandant des informations supplémentaires (notamment un exemple hello world) et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/1Pt5WJw9FO395mxqmregwE/1db7df9367b12a160560252afd701356/image26.png)\n\nCe prompt donne déjà d'excellents résultats. Effectuez l'exercice asynchrone suivant\_: répétez le prompt et demandez comment déployer l'application, en ajoutant plus de détails à chaque étape. Vous pouvez également transformer le prompt en conversation de suivi.\n\n> I want to create a Java Spring Boot application. Please explain the project structure and show a hello world example. Show how to build and deploy the application in CI/CD. (Je souhaite créer une application Java Spring Boot. Expliquez-moi la structure du projet et montrez-moi un exemple de type «\_hello world\_». Montrez-moi comment construire et déployer l'application dans le pipeline CI/CD.) \n> \n> I want to create a Java Spring Boot application. Please explain the project structure and show a hello world example. Show how to build and deploy the application in CI/CD, using container images. (Je souhaite créer une application Java Spring Boot. Expliquez-moi la structure du projet et montrez-moi un exemple de type «\_hello world\_». Montrez-moi comment compiler et déployer l'application dans le pipeline CI/CD, en utilisant des images de conteneurs.)\n> \n> I want to create a Java Spring Boot application. Please explain the project structure and show a hello world example. Show how to build and deploy the application in CI/CD, using container images. Use Kubernetes and GitOps in GitLab. (Je souhaite créer une application Java Spring Boot. Expliquez-moi la structure du projet et montrez-moi un exemple de type «\_hello world\_». Montrez-moi comment construire et déployer l'application dans le pipeline CI/CD en utilisant des images de conteneurs, ainsi que Kubernetes et GitOps dans GitLab.)\n\n### 6. Faites preuve de patience\n\nLes mots simples ou les phrases courtes peuvent ne pas générer les résultats souhaités, [comme le montre cet exemple vidéo](https://youtu.be/JketELxLNEw?t=1220). GitLab\_Duo\_Chat peut parfois deviner correctement à partir des données disponibles, mais peut également demander plus de contexte.\n\nExemple\_: le terme `labels` qui apparaît dans la documentation GitLab.\n\n![Prompt portant sur les labels et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/1ufVtn5FsVTVmC39DM3deS/4d74ad21f1f54737130ba580ad825d88/image12.png)\n\nLimitez la question aux énoncés de problèmes et ciblez l'utilisation du tableau des tickets.\n\n> Explain labels in GitLab. Provide an example for efficient usage with issue boards. (Expliquez-moi ce que sont les labels dans GitLab. Fournissez-moi un exemple de leur utilisation efficace dans les tableaux des tickets.)\n\n![Prompt demandant d'inclure un exemple et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/4PMYNg3t8jpKfXXFvy0gZH/33b634015ecb9575e31f07db9adc7b4f/image21.png)\n\nVous pouvez également formuler un énoncé de problème suivi d'une question et demander des exemples supplémentaires.\n\n> I don't know how to use labels in GitLab. Please provide examples, and how to use them for filters in different views. Explain these views with examples. (Je ne sais pas comment utiliser les labels dans GitLab. Fournissez-moi des exemples et expliquez-moi comment les utiliser pour les filtres dans différentes vues. Expliquez ces vues à l'aide d'exemples.)\n\n![Prompt énonçant un problème et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/2daZluJpFkeffkzllQmUBP/93e88f755d5722a7e0f83e0e211a851b/image10.png)\n\nÉvitez en outre les questions fermées et précisez le contexte.\n\n> Can you help me fix performance regressions? (Pouvez-vous m'aider à corriger les régressions de performance\_?)\n\n![Prompt demandant de l'aide pour corriger les régressions affectant les performances et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/VSHim2STPr6Nf859GlWuM/33d683962f029505e0a66f39185f6ac2/image18.png)\n\nFournissez plutôt davantage de contexte sur la régression affectant les performances, y compris les langages de programmation, les frameworks, la pile technologique et les environnements. L'exemple suivant utilise un environnement datant d'il y a plusieurs années, qui peut encore être utile aujourd'hui.\n\n> My PHP application encounters performance regressions using PHP 5.6 and MySQL 5.5. Please explain potential root causes, and how to address them. The app is deployed on Linux VMs. (Mon application PHP rencontre des régressions de performance avec PHP\_5.6 et MySQL\_5.5. Expliquez-moi les causes potentielles et comment y remédier. L'application est déployée sur des machines virtuelles Linux.)\n\n![Prompt plus détaillé et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/2WSbgJuRzHorMVKPJMuurf/1e24876aae6debafddea189ca6164c86/image24.png)\n\n### 7. Réinitialisez la conversation et lancez-en une nouvelle\n\nIl peut arriver que l'historique du chat montre une courbe d'apprentissage différente et ne fasse pas appel au contexte adéquat pour les questions de suivi. Il est également possible que GitLab\_Duo\_Chat ne puisse pas répondre aux questions spécifiques que vous avez posées. L'IA générative n'est pas prévisible. Elle peut donc parfois ne pas être en mesure de fournir certains exemples à l'instant précis. Cependant, elle peut les fournir dans sa réponse à une future question (ce comportement a été observé dans la version bêta de GitLab\_Duo\_Chat). Les grands modèles de langage (LLM) sous-jacents peuvent parfois insister pour donner une réponse spécifique, créant une boucle sans fin.\n\n> How can I get started creating an empty C# console application in VSCode? Please show a .gitignore and .gitlab-ci.yml configuration with steps for C#, and add security scanning for GitLab. Explain how solutions and projects in C# work, and how to add a test project on the CLI. (Comment puis-je commencer à créer une application console C# vide dans VS\_Code\_? Montrez-moi une configuration .gitignore et .gitlab-ci.yml avec des étapes pour C#, et ajoutez un scanning de sécurité pour GitLab. Expliquez-moi comment fonctionnent les solutions et les projets en C#, et comment ajouter un projet de test dans l'interface CLI.)\n\nAprès avoir posé la question ci-dessus et demandé un exemple de configuration, nous avons tenté de réduire la portée de la question afin d'obtenir une réponse plus adaptée. Nous n'avons pas obtenu le résultat escompté, car Chat prend en compte le contexte de l'historique du chat et fait référence aux réponses précédentes.\n\n> How can I get started creating an empty C# console application in VSCode? Please show a .gitignore and .gitlab-ci.yml configuration with steps for C#. (Comment puis-je commencer à créer une application console C# vide dans VS\_Code\_? Montrez-moi une configuration .gitignore et .gitlab-ci.yml avec les étapes pour C#.)\n\n![Prompt demandant des exemples de configuration et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/c7ExMo8DMLs2QGolIPd6C/504da2be7cbe64fa01a03b6cb00c7c3b/image23.png)\n\nPour forcer GitLab\_Duo\_Chat à utiliser un nouveau contexte, utilisez la commande slash `/reset` pour remettre la session à zéro. Répétez ensuite la question pour obtenir de meilleurs résultats. Vous pouvez également utiliser `/clean` ou `/clear` pour supprimer tous les messages de la conversation.\n\n### 8. Gagnez en productivité en utilisant les commandes slash dans l'IDE \n\n#### Explication du code\n\n- Q\_: Code généré\_? Code existant\_? Code hérité\_?\n- R\_: Utilisez la [commande slash `/explain` dans l'IDE](https://docs.gitlab.com/ee/user/gitlab_duo_chat.html#explain-code-in-the-ide).\n- R2\_: Affinez le prompt pour obtenir des réponses plus ciblées, par exemple\_: `/explain focus on potential shortcomings or bugs` (/explain Expliquez-moi en mettant l'accent sur les lacunes ou les bogues potentiels).\n\n![Prompt utilisant la commande slash /explain](//images.ctfassets.net/r9o86ar0p03f/1FSWZABjDb1F883ejugHR8/97162cc6474b93127fba18e1f62cda97/gitlab_duo_chat_slash_commands_explain_01.png)\n\n![Prompt affiné](//images.ctfassets.net/r9o86ar0p03f/1i7z6iSJSktgqLGs8PZFg9/3c81c9421b7be03baec6b8db87547114/image6.png)\n\n#### Réusinage du code\n\n- Q\_: Code illisible\_? Code spaghetti long\_? Aucune couverture de test\_?\n- R\_: Utilisez la [commande slash `/refactor` dans l'IDE](https://docs.gitlab.com/ee/user/gitlab_duo_chat.html#refactor-code-in-the-ide).\n- R2\_: Affinez le prompt pour effectuer des actions plus ciblées, par exemple réusiner du code pour obtenir des patterns orientés objet\_: `/refactor into object-oriented classes with methods and attributes` (/refactor Réusinez le code en classes orientées objet avec des méthodes et des attributs). \n\n![Prompt utilisant la commande slash /refactor](//images.ctfassets.net/r9o86ar0p03f/5POcJxOiuWiK2ADBcegkgR/4afa2f60a2310941a77416f1865d500e/image35.png)\n\n![Prompt affiné](//images.ctfassets.net/r9o86ar0p03f/5y9JAzISyaUurgWtohTun9/4418ec6efc1a8a2dd66e5609d14b6e99/image30.png)\n\n#### Génération de tests\n\n- Q\_: Le code peut être testé, mais créer les tests prend trop de temps\_?\n- R\_: Utilisez la [commande slash `/tests` dans l'IDE](https://docs.gitlab.com/ee/user/gitlab_duo_chat.html#write-tests-in-the-ide).\n\n- R2\_: Affinez le prompt pour utiliser des frameworks de test spécifiques ou des cibles de test. Vous pouvez également demander à GitLab\_Duo\_Chat de se concentrer sur le réusinage du code, puis de générer des tests\_: `/tests focus on refactoring the code into functions, and generate tests` (/tests Mettez l'accent sur le réusinage du code en fonctions pour générer des tests).\n\n![Prompt utilisant la commande slash /tests](//images.ctfassets.net/r9o86ar0p03f/1yhfIQcniJpcocwrYYMRqT/22e2019801e756e8ede9076d5d93ddb5/image29.png)\n\n![Prompt affiné](//images.ctfassets.net/r9o86ar0p03f/2VBnvwX2No2Rd7Yad7KMxM/22a311c2cf53cf25d26e6390027fb157/image4.png)\n\nDécouvrez d'autres cas pratiques de workflows de développement complets dans la documentation présentant des [exemples d'utilisation de GitLab\_Duo](https://docs.gitlab.com/ee/user/gitlab_duo_examples.html).\n\n### 9. Affinez le prompt pour les commandes slash\n\nVous trouverez dans cet article de nombreux conseils pour rendre vos prompts plus spécifiques. Cette approche contribue à améliorer la productivité d'un workflow alimenté par l'IA. De la même manière, les commandes slash permettent d'obtenir de meilleurs résultats dans GitLab\_Duo\_Chat.\n\nRécemment, un client a posé la question suivante\_: «\_L'explication de code utilisant `/explain` peut-elle générer des commentaires intégrés au code\_?\_». La réponse est non. Vous pouvez cependant poser des questions de suivi à l'aide de prompts dans Chat et demander un résumé sous la forme d'un commentaire de code. Le langage de programmation doit être indiqué.\n\nDans l'exemple suivant, un [code client HTTP C++ utilisant la bibliothèque cURL](https://gitlab.com/gitlab-da/use-cases/ai/ai-workflows/gitlab-duo-prompts/-/blob/5cc9bdd65ee8ee16c548bea0402c18f8209d4d06/chat/slash-commands/c++/cli.cpp) nécessite plus de documentation. Vous pouvez personnaliser le prompt `/explain` en fournissant des instructions plus précises. Vous pouvez donc demander à GitLab\_Duo\_Chat d'expliquer le code en ajoutant des commentaires au code, puis copier-coller le prompt ainsi obtenu dans l'éditeur.\n\n> /explain add documentation, rewrite the code snippet (/explain Ajoutez de la documentation, réécrivez l'extrait de code)\n\n![Prompt demandant d'ajouter de la documentation/de réécrire l'extrait de code et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/7MRtMT1kgIOIh0PewiSSSJ/a40d82c9ca40c43d7c6795d67d7e04ea/image13.png)\n\nVous pouvez également demander à GitLab\_Duo\_Chat de réusiner (via la commande `/refactor`) le code source et de générer les commentaires dans le code manquants via un prompt personnalisé.\n\n> /refactor add code comments and documentation (/refactor en ajoutant des commentaires de code et de la documentation)\n\n![Prompt demandant de réusiner le code source et de générer des commentaires de code](//images.ctfassets.net/r9o86ar0p03f/6b9kAr2A27UKdJoTEUru9E/048b6a9f7946c602ade466e2849cb3ea/image15.png)\n\n### 10. Utilisez les commandes slash de manière créative\n\nLorsque l'IA ne connaît pas la réponse à une question sur le code source ou le langage de programmation, réfléchissez à la manière dont les commandes slash `/explain`, `/refactor` et `/tests` peuvent vous aider.\n\nDans l'exemple suivant, une chaîne de requête SQL en C++ est créée sur une seule ligne. Pour améliorer la lisibilité et avoir la possibilité d'ajouter plus de colonnes de base de données à l'avenir, il peut être utile de choisir une chaîne multiligne.\n\n> std::string sql = \"CREATE TABLE IF NOT EXISTS users (id INTEGER PRIMARY KEY AUTOINCREMENT, name TEXT NOT NULL, email TEXT NOT NULL)\";\n\nVous pouvez demander à GitLab\_Duo\_Chat des précisions à ce sujet, par exemple en posant la question suivante\_:\n\n> How to create a string in C++ using multiple lines? (Comment créer une chaîne en C++ utilisant plusieurs lignes\_?)\n\nChat peut répondre avec une explication et éventuellement un exemple de code source. Dans ce contexte, il peut proposer de créer une valeur de chaîne C++ sur plusieurs lignes, par exemple en utilisant le caractère `\\n`, affectée à une variable. \n\nLa condition requise est plutôt de formater uniquement le code écrit et d'affecter des valeurs de variable dans plusieurs lignes. Il n'est pas nécessaire que la valeur de chaîne elle-même contienne une représentation de chaîne multiligne. \n\nVous disposez d'une alternative pour fournir un contexte supplémentaire dans VS\_Code et le Web\_IDE\_: sélectionnez le code source en question, cliquez avec le bouton droit de la souris et accédez au menu `GitLab Duo Chat > Refactor`. Cela permet d'ouvrir la fenêtre de prompt de GitLab \_Duo\_Chat et de déclencher immédiatement la tâche de code `/refactor`.\n\nCette dernière peut toutefois ne pas produire les résultats attendus. Le réusinage d'une chaîne SQL sur une seule ligne offre plusieurs possibilités\_: utiliser plusieurs lignes pour plus de lisibilité, créer des constantes et ainsi de suite.\n\nLes tâches de code fournissent une option pour rendre le prompt plus spécifique. Vous pouvez ajouter plus de texte après la commande `/refactor` et demander à GitLab\_Duo\_Chat d'utiliser un type de code, un algorithme ou un design pattern spécifique. \n\nRéessayons en sélectionnant le code source, en affichant la fenêtre du chat, en saisissant le prompt suivant et en appuyant sur `Entrée`. \n\n> /refactor into a multi-line written string. Show different approaches for all C++ standards. (/refactor Réusinez le code en une chaîne écrite multiligne. Montrez-moi différentes approches pour tous les standards C++.\n\n![Prompt demandant de réusiner le code en une chaîne écrite multiligne et réponse obtenue](//images.ctfassets.net/r9o86ar0p03f/A2mhrLSH5N10f0Hw8razk/bb5868f7d178d4da3d2ee2855ec0f4ca/image17.png)\n\n**Astuce\_:** vous pouvez utiliser la fonctionnalité de suggestions de code de GitLab\_Duo pour affiner encore plus le code source après le réusinage, ou utiliser d'autres personnalisations de prompt `/refactor`.\n\n>/refactor into a multi-line written string, show different approaches (/refactor Réusinez le code en une chaîne écrite multiligne, montrez-moi différentes approches)\n>\n> /refactor into multi-line string, not using raw string literals (/refactor Réusinez le code en une chaîne multiligne, sans utiliser de littéral de chaîne brut)\n>\n> /refactor into a multi-line written string. (/refactor en une chaîne écrite multiligne.) Faites en sorte que le nom de la table soit paramétrable\n\nDécouvrez une autre approche avec le type `stringstream` dans la vidéo [GitLab\_Duo Coffee Chat\_: Refactor C++ functions into OOP classes for abstract database handling](https://www.youtube.com/watch?v=Z9EJh0J9358) et sur la page [diff de la MR](https://gitlab.com/gitlab-da/use-cases/ai/gitlab-duo-coffee-chat/gitlab-duo-coffee-chat-2024-01-23/-/commit/7ea233138aed46d77e6ce0d930dd8e10560134eb#4ce01e4c84d4b62df8eed159c2db3768ad4ef8bf_33_35). \n\n#### Explication des vulnérabilités\n\nLe résultat peut être aléatoire, mais vous pouvez également exécuter la commande slash `/explain` pour obtenir des explications sur les failles de sécurité. Dans cet exemple, le [code C](https://gitlab.com/gitlab-da/use-cases/ai/ai-workflows/gitlab-duo-prompts/-/blob/5a5f293dfbfac7222ca4013d8f9ce9b462e4cd3a/chat/slash-commands/c/vuln.c) contient plusieurs vulnérabilités liées notamment à des dépassements de mémoire tampon strcpy(), à des fichiers modifiables par tout le monde et à des attaques de type race condition.\n\n> /explain why this code has multiple vulnerabilities (/explain Expliquez-moi pourquoi ce code présente plusieurs vulnérabilités)\n\n![Prompt demandant des explications sur les multiples vulnérabilités du code](//images.ctfassets.net/r9o86ar0p03f/5yaB0m0ocrJZj70VREuUk0/525ac7ae7462bfdbeae64ac9fa534dc3/image20.png)\n\n#### Réusinage du code C\_ en langage Rust\n\nLe langage Rust garantit la sécurité de la mémoire. Vous pouvez demander à GitLab\_Duo\_Chat de réusiner le [code\_C](https://gitlab.com/gitlab-da/use-cases/ai/ai-workflows/gitlab-duo-prompts/-/blob/5a5f293dfbfac7222ca4013d8f9ce9b462e4cd3a/chat/slash-commands/c/vuln.c)  vulnérable en code Rust, en utilisant la commande `/refactor into Rust`. Entraînez-vous avec des prompts plus précis afin d'obtenir de meilleurs résultats.\n\n> /refactor into Rust and use high level libraries (/refactor Réusinez le code en Rust et utilisez des bibliothèques de haut niveau)\n\n![Prompt dans Chat](//images.ctfassets.net/r9o86ar0p03f/2T7D2Y5F4RxfEjZeMwzFwj/e2015aeff80c0210089d7dc816b7e96a/image8.png)\n\n### Raccourcis \n\nEssayez ces raccourcis dans votre environnement et entraînez-vous à utiliser les prompts asynchrones dans GitLab\_Duo\_Chat.\n\n1. Inspectez le code vulnérable des CVE et demandez le problème rencontré et comment y remédier, en utilisant le prompt `/explain why is this code vulnerable` (/explain Expliquez pourquoi ce code est vulnérable). \n**Astuce\_:** importez des projets open source dans GitLab pour tirer parti des explications de code de GitLab\_Duo\_Chat.\n1. Essayez de réusiner le code dans de nouveaux langages de programmation pour faciliter la migration du code hérité.\n1. Vous pouvez également essayer de réusiner le code d'une configuration Jenkins dans un pipeline GitLab\_CI/CD, en utilisant le prompt `/refactor into GitLab CI/CD configuration` (/refactor Réusinez en une configuration GitLab\_CI/CD). \n\n### Exercices amusants \n\nEssayez de convaincre GitLab\_Duo\_Chat de se comporter comme l'assistant Clippy.\n![Prompt dans Chat](//images.ctfassets.net/r9o86ar0p03f/7Ina5Pl649a9MkHUOiFDJt/45c7d5e732e004bfae744732f4469d23/image22.png)\n\nPosez une question à propos de la mission de GitLab\_: «\_Tout le monde peut contribuer\_».\n\n![Prompt dans Chat](//images.ctfassets.net/r9o86ar0p03f/2iTw3UgoIy7Jwo2ogBCJK4/65ea627a37edad89fcc061701a01b359/image33.png)\n\n### En savoir plus\n\nNous mettons à disposition de nombreux environnements et vous proposons différents défis. Nous avons mis à jour la [documentation sur GitLab\_Duo\_Chat](https://docs.gitlab.com/ee/user/gitlab_duo_chat.html) en ajoutant plus d'exemples pratiques. Nous avons également ajouté une nouvelle section contenant des [exemples de cas d'utilisation de GitLab\_Duo](https://docs.gitlab.com/ee/user/gitlab_duo_examples.html) contenant des informations sur les workflows DevSecOps alimentés par l'IA, notamment à l'aide de GitLab\_Duo\_Chat.\n\nIl est plus facile d'apprendre à utiliser GitLab\_Duo en relevant des défis ludiques et en travaillant sur un vrai code de production. Une nouvelle série de sessions d'apprentissage GitLab\_Duo\_Coffee\_Chat a été publiée en 2024. Vous pouvez également regarder les enregistrements de [cette playlist YouTube](https://www.youtube.com/playlist?list=PL05JrBw4t0Kp5uj_JgQiSvHw1jQu0mSVZ). Si vous êtes client de GitLab et que vous souhaitez rejoindre une session GitLab\_Duo\_Coffee\_Chat pour apprendre ensemble, indiquez-le dans [cet epic de planification](https://gitlab.com/groups/gitlab-com/marketing/developer-relations/-/epics/476). \n\n> Vous voulez commencer à utiliser GitLab\_Duo\_Chat\_? [Commencez votre essai gratuit dès aujourd'hui](https://about.gitlab.com/fr-fr/solutions/gitlab-duo-pro/sales/).\n"
  category: IA/ML
  tags:
    - AI/ML
    - tutorial
    - DevSecOps platform
    - features
config:
  slug: 10-best-practices-for-using-ai-powered-gitlab-duo-chat
  featured: true
  template: BlogPost
